let list = []
let g_setIntel = 0
let hasCheckTB = false

$(function () {
  let pluginDiv = document.createElement('div')
  pluginDiv.innerHTML = `
	<div style="position: fixed;right: 100px;top:210px;z-index:100001;display: flex;justify-content: space-around;align-items: center;">
		<div id="backOrder" style="margin-right:10px;line-height:40px;font-size:20px;color:white;height:40px;text-align: center; background-image: linear-gradient(to top, #37ecba 0%, #72afd3 100%);padding:5px 20px; cursor:pointer;border-radius:5px">返回礼品网下单</div>
    <div id="tbDecrypt" style="margin-right:10px;line-height:40px;font-size:20px;color:white;height:40px;text-align: center; background-image: linear-gradient(to right, #fa709a 0%, #fee140 100%);padding:5px 20px; cursor:pointer;border-radius:5px">开始解密</div>
    <div id="copyOrder" style="margin-right:10px;line-height:40px;font-size:20px;color:white;height:40px;text-align: center; background-image: linear-gradient(to right, #b8cbb8 0%, #b8cbb8 0%, #b465da 0%, #cf6cc9 33%, #ee609c 66%, #ee609c 100%);padding:5px 20px; cursor:pointer;border-radius:5px">复制订单信息</div>
	</div>`
  document.body.appendChild(pluginDiv)

  $('#backOrder').click(() => {
    pushOrder()
  })

  $('#copyOrder').click(() => {
    copyOrder()
  })

  $('#tbDecrypt').click(() => {
    let $checked = $('.J_Trigger')
    if ((!$checked) || (!$checked.length)) {
      showMessage('请先勾选需要解密的订单!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
    } else {
      //$.MyCommon.PageLoading({ loadingTips: '解密中，请耐心等待...' })
      $('#backOrder').hide()
      $('#copyOrder').hide()
      $('#tbDecrypt').html('解密中...')
      hasCheckTB = false
      decrypt()
    }
  })
})

function format (str) {
  str = str.replace('/', ' ').replace('/', ' ').trim()
  return str
}

function decrypt () {
  list.length = 0
  let listDom = $('tbody.j_expressTbody')
  let hasChecked = false
  listDom.each(function () {
    let checked = $(this).find('input.trigger.J_Trigger').prop('checked')
    if (!checked) {
      return true
    }
    $(this).find('.logis-info .info>img').trigger('click');
    hasChecked = checked
  })
  $('#tbDecrypt').html('重新解密')
    $('#loadingPage').hide()
    $('#backOrder').show()
    $('#copyOrder').show()
    showMessage('已全部解密完成!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
  if (!hasChecked) {
    showMessage('请先勾选需要解密的订单!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
  }
  return hasChecked
}

function copyOrder () {
  if (checkOrder()) {
    let orderList = list.join('\r\n')
    const textarea = document.createElement('textarea')
    textarea.value = orderList
    document.body.appendChild(textarea)
    textarea.select()
    if (document.execCommand('copy')) {
      document.execCommand('copy')
      showMessage('复制成功!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
    } else {
      showMessage('当前浏览器不支持复制功能!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
    }
    document.body.removeChild(textarea)
  }
}

function pushOrder () {
  if (checkOrder()) {
    let orderList = list.join('\r\n')
    console.log(orderList);
    let result = ''
    chrome.extension.sendRequest({
      type: 'backToLiPinGift',
      orderType: 'taobao',
      orderList: orderList
    }, function (response) {
      console.log(response)
      result = response
    })
    setTimeout(() => {
      if (result === '') {
        showMessage('找不到回去的路啦，返回失败!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
      } else {
        showMessage('若长时间没有返回，请检查是否把网站关闭了!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
      }
    }, 1000)
  }
}

function showMessage (content, duration, isCenter, animateIn, animateOut) {
  let myAnimateIn = animateIn || 'fadeIn'
  let myAnimateOut = animateOut || 'fadeOut'
  let myContent = content || '这是一个提示信息'
  let myDuration = duration || '3000'
  let myIsCenter = isCenter || false
  $('body').toast({
    position: 'fixed',
    animateIn: myAnimateIn,
    animateOut: myAnimateOut,
    content: myContent,
    duration: myDuration,
    isCenter: myIsCenter,
  })
}


function checkOrder () {
  list.length = 0
  let listDom = $('tbody.j_expressTbody')
  let hasChecked = false
  listDom.each(function () {
    let checked = $(this).find('input.trigger.J_Trigger').prop('checked')
    if (!checked) {
      return true
    }
    $(this).find('.logis-info .info>img').trigger('click');
    hasChecked = checked
    let orderNumber = $(this).find('.order-title .order-number').text().replace('订单编号：', '')
    let orderInfoDom = $(this).find('.logis-info .info').clone()
    orderInfoDom.find('.ww').remove()
    let orderInfo = orderInfoDom.text().replace(/\n/g, '').replace(/ {2,}/g, ' ').trim()
    var infoList = orderInfo.split("，");
    if(infoList.length == 1){
      var infoList = orderInfo.split(",");
    }
    let addressInfo = format(infoList[2].trim() + ',' + infoList[3].trim() + ',' + infoList[0].trim()+','+orderNumber)
    list.push(addressInfo)
  })
  if (!hasChecked) {
    showMessage('请先勾选需要发货的订单!', 3000, true, 'bounceInUp-hastrans', 'bounceOutDown-hastrans')
  }
  return hasChecked
}
